/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/*!
 * Next JS
 * Copyright (c)2011 Xenophy.CO.,LTD All rights Reserved.
 * http://www.xenophy.com
 */

// {{{ NX.app.Dispatcher.dispatch

NX.require('NX.app.AbstractController');

module.exports = function() {

    return function(req, res, next) {

        var config = req.config;

        NX.require('NX.app.' + config.controllerType + 'Controller');

        // コントローラー生成
        var controller = NX.create('NX.app.' + config.controllerType + 'Controller', config);

        // リクエストオブジェクトにコントローラー設定
        req.controller = controller;

        // コントローラー初期化
        controller.init(req, res, function() {

            // アクション実行
            controller.execute(req, res, function() {

                // 処理結果レンダリング
                controller.render(req, res, next);

            });

        });

    }

};


// }}}

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * c-hanging-comment-ender-p: nil
 * End:
 */
